<?php
/*
Plugin Name: MPVC
Version: 1.0.a
Description: Plugin permettant de modifier la classe des deux paragraphes utilise dans les vignettes de categorie (le nombre d'images ainsi que le commentaire) et les mettre en forme de facon plus personnelle
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=170
*/

/* ----------------------------------------------------------------------
	Plugin réalisé selon le tutoriel de flipflip 
	http://phpwebgallery.net/doc/doku.php/fr:utiliser:faire_un_plugin

1.0   - version initale
1.0.a - ajout de l'URI pour compatibilité avec UpToD@te
 
   ---------------------------------------------------------------------- */

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');


class MPVC_Plugin
{ 
    var $my_config;

	/* charge la configuration dans le fichier data.dat */
	function load_config()
	{
	        $x = @file_get_contents( dirname(__FILE__).'/data.dat' );
	        if ($x!==false)
	        {
	            $c = unserialize($x);
	            $this->my_config = $c;
	        }
	 
	        if((!isset($this->my_config)))
	        {
		    // noms par défaut des classes 
	            $this->my_config['MPVC_CSSId_NbImg'] = 'MPVC_NbImg';
	            $this->my_config['MPVC_CSSId_Comment'] = 'MPVC_Comment';
		    // valeurs par défaut des classes 		
	            $this->my_config['MPVC_NbImg'] = 'font-style: italic;';
	            $this->my_config['MPVC_Comment'] = 'text-align:justify;
padding-top:8px;
padding-right:8px;
border-top:1px solid #404040;';
	            $this->save_config();
	        }
	}
	


	/* sauvegarde de la configuration dans data.dat */
	function save_config()
	{
	 $file = fopen( dirname(__FILE__).'/data.dat', 'w' );
	 fwrite($file, serialize($this->my_config) );
	 fclose( $file );
	}


	/* intégration du plugin dans l'interface d'administration */
	function plugin_admin_menu($menu)
	{
	 array_push($menu,
	            array(
	                'NAME' => 'MPVC',
	                'URL' => get_admin_plugin_menu_link(dirname(__FILE__).'/admin/MPVC_admin.php')
	                 ));
	 return $menu;
	}


	/* ajoute la déclaration CSS dans la page */
	function Modifie_CSS()
	{
	  global $template;

	  $text = "";

	  if(($this->my_config['MPVC_CSSId_NbImg']!='')&&($this->my_config['MPVC_NbImg']!=''))
		{ $text.='.'.$this->my_config['MPVC_CSSId_NbImg'].' { '.$this->my_config['MPVC_NbImg'].' }'.chr(13).chr(10); }
	  if(($this->my_config['MPVC_CSSId_Comment']!='')&&($this->my_config['MPVC_Comment']!=''))
		{ $text.='.'.$this->my_config['MPVC_CSSId_Comment'].' { '.$this->my_config['MPVC_Comment'].' }'; }
	  
	  if($text!="")
	  {
	    $template->assign_block_vars('head_element', array('CONTENT' => '<style type="text/css"> '.$text.' </style>'));
	  }
	}


	/* modifie les paragraphes des vignettes de catégories */
	function Modifie_vignette($content) 
	{
		if($this->my_config['MPVC_CSSId_NbImg']!='')
		{ $this->personal_replace_tpl_code('mainpage_categories', '<p>{categories.category.CAPTION_NB_IMAGES}</p>', '<p class="'.$this->my_config['MPVC_CSSId_NbImg'].'">{categories.category.CAPTION_NB_IMAGES}&nbsp;</p>'); }

		if($this->my_config['MPVC_CSSId_Comment']!='')
		{ $this->personal_replace_tpl_code('mainpage_categories', '<p>{categories.category.DESCRIPTION}&nbsp;</p>', '<p class="'.$this->my_config['MPVC_CSSId_Comment'].'">{categories.category.DESCRIPTION}&nbsp;</p>'); }
	}


	/* remplace un bout de code d'un template */
	function personal_replace_tpl_code($tlp_handle, $old, $new)
	{
	 global $template;
	 $template->loadfile($tlp_handle);
	 $template->uncompiled_code[$tlp_handle] = str_replace($old, $new, $template->uncompiled_code[$tlp_handle]);
	}
}
$obj = new MPVC_Plugin();
$obj->load_config();
 
add_event_handler('get_admin_plugin_menu_links', array(&$obj, 'plugin_admin_menu') ); 
add_event_handler('loc_index_category_thumbnail', array(&$obj, 'Modifie_vignette')); 
add_event_handler('loc_end_page_header', array(&$obj, 'Modifie_CSS'));
set_plugin_data($plugin['id'], $obj)

?>
